# -*- coding: utf-8 -*-

from rest_framework import serializers
from rest_framework_recursive.fields import RecursiveField

from thx.role.core.serializers import ThuxRoleSerializerMixin

from ... import models


# PROFILE
class ProfileSerializer(ThuxRoleSerializerMixin, serializers.ModelSerializer):
    class Meta:
        ref_name = 'v1_role_profile'
        model = models.Profile
        fields = '__all__'


# ROLE
class RoleSerializer(ThuxRoleSerializerMixin, serializers.ModelSerializer):
    class Meta:
        ref_name = 'v1_role_role'
        model = models.Role
        fields = '__all__'


# REQUIRED FIELD
class RequiredFieldSerializer(ThuxRoleSerializerMixin, serializers.ModelSerializer):
    class Meta:
        ref_name = 'v1_role_required_field'
        model = models.RequiredField
        fields = '__all__'


# STATUS FLOW
class StatusFlowSerializer(ThuxRoleSerializerMixin, serializers.ModelSerializer):
    class Meta:
        ref_name = 'v1_role_status_flow'
        model = models.StatusFlow
        fields = '__all__'


# USED FIELD
class UsedFieldSerializer(ThuxRoleSerializerMixin, serializers.ModelSerializer):
    class Meta:
        ref_name = 'v1_role_used_field'
        model = models.UsedField
        fields = '__all__'


# FILTER
class FilterSerializer(ThuxRoleSerializerMixin, serializers.ModelSerializer):
    class Meta:
        ref_name = 'v1_role_filter'
        model = models.Filter
        fields = '__all__'


# MENU
class MenuSerializer(ThuxRoleSerializerMixin, serializers.ModelSerializer):
    children = RecursiveField('MenuSerializer', many=True)

    class Meta:
        ref_name = 'v1_role_menu'
        model = models.Menu
        fields = '__all__'
