# -*- coding: utf-8 -*-
from django.utils.translation import gettext_lazy as _

children = []
models = [
    {'model_name': 'profile', 'model_label': _('profile'), 'model_label_plural': _('profiles')},
    {'model_name': 'role', 'model_label': _('role'), 'model_label_plural': _('roles')},
    {'model_name': 'requiredfield', 'model_label': _('required field'), 'model_label_plural': _('required fields')},
    {'model_name': 'statusflow', 'model_label': _('status flow'), 'model_label_plural': _('status flows')},
    {'model_name': 'usedfield', 'model_label': _('used field'), 'model_label_plural': _('used fields')},
    {'model_name': 'filter', 'model_label': _('filter'), 'model_label_plural': _('filters')},
    {'model_name': 'menu', 'model_label': _('menu'), 'model_label_plural': _('menus')},
]

for model in models:
    add_entry = {
        "title": _("add {}").format(model['model_label']),
        "url_name": f"admin:role_{model['model_name']}_add",
        "perms": [f"role.add_{model['model_name']}"],
    }
    children.append(add_entry)
    list_entry = {
        "title": _("{} list").format(model['model_label_plural']),
        "url_name": f"admin:role_{model['model_name']}_changelist",
        "perms": [
            f"role.view_{model['model_name']}",
            f"role.change_{model['model_name']}"
        ],
    }
    children.append(list_entry)

menu_items = [{
    'title': _('role'),
    'url_name': {'viewname': 'admin:app_list', 'kwargs': {'app_label': 'role'}},
    'perms': ['role.*'],
    'children': children
}]
