# Generated by Django 2.2.24 on 2021-06-08 06:48

import django.contrib.postgres.fields.jsonb
import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Role',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('name', models.CharField(max_length=255, verbose_name='name')),
                ('app_label', models.CharField(max_length=100, verbose_name='app label')),
                ('model_name', models.CharField(max_length=100, verbose_name='model name')),
                ('codename', models.CharField(max_length=255, verbose_name='codename')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_role_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_role_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
                ('users', models.ManyToManyField(blank=True, related_name='roles', to=settings.AUTH_USER_MODEL, verbose_name='users')),
            ],
            options={
                'verbose_name': 'role',
                'verbose_name_plural': 'roles',
                'ordering': ('ordering', 'app_label', 'model_name', 'codename'),
                'permissions': (('list_role', 'Can list role'), ('detail_role', 'Can detail role'), ('enable_role', 'Can enable role'), ('disable_role', 'Can disable role')),
                'unique_together': {('app_label', 'model_name', 'codename')},
            },
        ),
        migrations.CreateModel(
            name='UserRole',
            fields=[
            ],
            options={
                'ordering': ('role__app_label', 'role__model_name', 'role__name', 'role__name', 'user__username'),
                'proxy': True,
                'indexes': [],
                'constraints': [],
            },
            bases=('role.role_users',),
        ),
        migrations.CreateModel(
            name='Menu',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('title', models.CharField(max_length=255, verbose_name='title')),
                ('language_code', models.CharField(max_length=2, verbose_name='language code')),
                ('router', models.CharField(max_length=255, verbose_name='router')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_menu_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_menu_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
                ('parent', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='children', to='role.Menu', verbose_name='parent')),
                ('roles', models.ManyToManyField(blank=True, related_name='menus', to='role.Role', verbose_name='roles')),
            ],
            options={
                'verbose_name': 'menu',
                'verbose_name_plural': 'menu',
                'ordering': ('ordering', 'language_code', 'parent', 'title'),
                'permissions': (('list_menu', 'Can list menu'), ('detail_menu', 'Can detail menu'), ('enable_menu', 'Can enable menu'), ('disable_menu', 'Can disable menu')),
            },
        ),
        migrations.CreateModel(
            name='UsedField',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('from_status', models.CharField(help_text='e.g.: 1 -> "1", "create" -> "create"', max_length=50, verbose_name='from status')),
                ('action', models.CharField(help_text='e.g.: "create", "enable", "destroy"', max_length=50, verbose_name='action')),
                ('fields', django.contrib.postgres.fields.jsonb.JSONField(help_text='e.g.: ["field1", "field2"]', verbose_name='fields')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_usedfield_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_usedfield_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='used_fields', to='role.Role', verbose_name='role')),
            ],
            options={
                'verbose_name': 'used field',
                'verbose_name_plural': 'used fields',
                'ordering': ('ordering', 'role__app_label', 'role__model_name', 'role__name', 'from_status', 'action'),
                'permissions': (('list_usedfield', 'Can list used field'), ('detail_usedfield', 'Can detail used field'), ('enable_usedfield', 'Can enable used field'), ('disable_usedfield', 'Can disable used field')),
                'unique_together': {('role', 'from_status', 'action')},
            },
        ),
        migrations.CreateModel(
            name='StatusFlow',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('from_status', models.CharField(help_text='e.g.: 1 -> "1", "create" -> "create"', max_length=50, verbose_name='from status')),
                ('to_status', django.contrib.postgres.fields.jsonb.JSONField(help_text='e.g.: ["status1", "status2"]', verbose_name='to status')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_statusflow_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_statusflow_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='status_flows', to='role.Role', verbose_name='role')),
            ],
            options={
                'verbose_name': 'status flow',
                'verbose_name_plural': 'status flows',
                'ordering': ('ordering', 'role__app_label', 'role__model_name', 'role__name', 'from_status'),
                'permissions': (('list_statusflow', 'Can list status flow'), ('detail_statusflow', 'Can detail status flow'), ('enable_statusflow', 'Can enable status flow'), ('disable_statusflow', 'Can disable status flow')),
                'unique_together': {('role', 'from_status')},
            },
        ),
        migrations.CreateModel(
            name='RequiredField',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('from_status', models.CharField(help_text='e.g.: 1 -> "1", "create" -> "create"', max_length=50, verbose_name='from status')),
                ('fields', django.contrib.postgres.fields.jsonb.JSONField(help_text='e.g.: ["field1", "field2"]', verbose_name='fields')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_requiredfield_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_requiredfield_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='required_fields', to='role.Role', verbose_name='role')),
            ],
            options={
                'verbose_name': 'required field',
                'verbose_name_plural': 'required fields',
                'ordering': ('ordering', 'role__app_label', 'role__model_name', 'role__name', 'from_status'),
                'permissions': (('list_requiredfield', 'Can list required field'), ('detail_requiredfield', 'Can detail required field'), ('enable_requiredfield', 'Can enable required field'), ('disable_requiredfield', 'Can disable required field')),
                'unique_together': {('role', 'from_status')},
            },
        ),
        migrations.CreateModel(
            name='Filter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('action', models.CharField(help_text='e.g.: "create", "enable", "destroy"', max_length=50, verbose_name='action')),
                ('codename', models.CharField(max_length=255, verbose_name='codename')),
                ('description', models.TextField(blank=True, null=True, verbose_name='description')),
                ('code', models.TextField(default='Q()', verbose_name='code')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_filter_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='role_filter_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='filters', to='role.Role', verbose_name='role')),
            ],
            options={
                'verbose_name': 'filter',
                'verbose_name_plural': 'filters',
                'ordering': ('ordering', 'role__app_label', 'role__model_name', 'codename'),
                'permissions': (('list_filter', 'Can list filter'), ('detail_filter', 'Can detail filter'), ('enable_filter', 'Can enable filter'), ('disable_filter', 'Can disable filter')),
                'unique_together': {('role', 'codename')},
            },
        ),
    ]
